import { BucketedUserConfig } from '@devcycle/types';
import { DVCPopulatedUser } from './User';
declare type PromiseResolver = {
    resolve: (value: BucketedUserConfig) => void;
    reject: (err?: any) => void;
};
/**
 * Ensures we only have one active config request at a time
 * any calls made while another is ongoing will be merged together by using the latest user object provided
 */
export declare class ConfigRequestConsolidator {
    private requestConfigFunction;
    private handleConfigReceivedFunction;
    private nextUser;
    currentPromise: Promise<BucketedUserConfig> | null;
    resolvers: PromiseResolver[];
    constructor(requestConfigFunction: (user: DVCPopulatedUser) => Promise<BucketedUserConfig>, handleConfigReceivedFunction: (config: BucketedUserConfig, user: DVCPopulatedUser) => void, nextUser: DVCPopulatedUser);
    queue(user?: DVCPopulatedUser): Promise<BucketedUserConfig>;
    private processQueue;
    private performRequest;
}
export {};
